#include <Agents/Agent.hpp>
#include <Agents/Perception/Perception.hpp>
#include <Environment/PictureEnvironment.hpp>

Agent::Agent()
{
}

int PERCEPTION_SIZE = 2;

Agent::Agent(PictureEnvironment* iEnvironment, int iDotSize, int iMoveSize)
{
	//uint32_t WHITE = 0xFFFFFFFF;
	fEnvironment = iEnvironment;
	fDotSize = iDotSize;
	fMoveSize = iMoveSize;
	fCurrentPerception = Perception(PERCEPTION_SIZE, PERCEPTION_SIZE);
	//fColor = sf::Color(rand() % 0xFFFFFFFFFFFF);
	uint32_t vRand = (((double)rand() / RAND_MAX) * 0xFFFFFFFFU);

	fColor = sf::Color(vRand);
	//fColor = sf::Color(((rand() % fColor.Red.toInteger())));
	fEnvWidth = iEnvironment->getWidth();
	fEnvHeight = iEnvironment->getHeight();

	fXPos = fEnvWidth / 2;
	fYPos = fEnvHeight / 2;
}

void Agent::loop()
{
	move();
	this->paint();
}

void Agent::move()
{
	double vRand = rand() % (fMoveSize + 1);
	fXPos += vRand - fMoveSize / 2;
	vRand = rand() % (fMoveSize + 1);
	fYPos += vRand - fMoveSize / 2;
}

void Agent::paint()
{
	fEnvironment->paint(fXPos, fYPos, fColor);
}