#include <Agents/Agent.hpp>
#include <Environment/PictureEnvironment.hpp>

StraightPaintAgent::StraightPaintAgent(PictureEnvironment* iEnvironment, int iDotSize, int iMoveSize, int iTolerance) :
	RepaintAgent(iEnvironment, iDotSize, iMoveSize, iTolerance)
{
	init();
}

void StraightPaintAgent::init()
{
	RepaintAgent::init();

	//Initalize list of possible movement vectors
	fMovements = std::vector<std::vector<int>>();
	if (rand() % 2)
	{
		for (int i = 0; i <= fMoveSize; i++)
		{
			fMovements.push_back({ i, 0 });
			fMovements.push_back({ -i, 0 });
		}
	}
	else
	{
		for (int j = 0; j <= fMoveSize; j++)
		{
			fMovements.push_back({ 0, j });
			fMovements.push_back({ 0, -j });
		}
	}
}
